##################################################################
# TITLE: Boot Up Code
# AUTHOR: Steve Rhoads (rhoadss@yahoo.com)
# DATE CREATED: 1/12/02
# FILENAME: boot.asm
# PROJECT: Plasma CPU core
# COPYRIGHT: Software placed into the public domain by the author.
#    Software 'as is' without warranty.  Author liable for nothing.
# DESCRIPTION:
#    Initializes the stack pointer and jumps to main().
##################################################################
   #Reserve 512 bytes for stack
   .comm InitStack, 512

   .text
   .align 2
   .global entry
   .ent	entry
entry:
   .set noreorder

   #These four instructions should be the first instructions.
   #convert.exe previously initialized $gp, .sbss_start, .bss_end, $sp
   
StartTest:
   mtc0  $0,$12             #disable interrupts
   lui   $20,0x2000         #serial port write address
   ori   $20,$20,0x8      
   
   ori   $23,$0,'\r'       
   ori   $22,$0,'X'         #'X' letter
   ori   $21,$0,'\n'        #<CR> letter
   ori   $24,$0,0x0f80      #temp memory
   mtc0 $20,$23   
   li    $2,0x00000000   
   li    $3,0x00000000
   li    $4,0x00000000 
   mfc0 $17,$23


   
   Test:
   ori   $2,$0,'T'
   sb    $2,0($20)
   ori   $2,$0,'e'
   sb    $2,0($20)
   ori   $2,$0,'s'
   sb    $2,0($20)
   ori   $2,$0,'t'
   sb    $2,0($20)
   sb    $23,0($20)
   sb    $21,0($20)
   
   jal   uart_empty




 #Muli_div:

   ori   $2,$0,'M'
   sb    $2,0($20)
   ori   $2,$0,'u'
   sb    $2,0($20)
   ori   $2,$0,'l'
   sb    $2,0($20)
   ori   $2,$0,'t'
   sb    $2,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

#mult
   ori   $2,$0,'a'
   sb    $2,0($20)

   ori   $4,$0,13 
   ori   $3,$0,5
   mult  $3,$4
   mflo  $2
   sb    $2,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

#div
   ori   $2,$0,'b'
   sb    $2,0($20)

   ori   $4,$0,65*3 
   ori   $3,$0,3
   div   $0,$4,$3
   mflo  $2
   sb    $2,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   



   
 ArthmeticTest:
   ori   $2,$0,'A'
   sb    $2,0($20)
   ori   $2,$0,'r'
   sb    $2,0($20)
   ori   $2,$0,'i'
   sb    $2,0($20)
   ori   $2,$0,'t'
   sb    $2,0($20)
   ori   $2,$0,'h'
   sb    $2,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #a: ADD
   ori   $2,$0,'a'
   sb    $2,0($20)

   ori   $4,$0,60 
   ori   $3,$0,5
   add   $2,$3,$4
   sb    $2,0($20)
   sb    $23,0($20)
   sb    $21,0($20)


   #b: ADDI
   ori   $2,$0,'b'
   sb    $2,0($20)
   ori   $4,$0,60
   addi  $2,$4,5
   sb    $2,0($20)    #A
   sb    $23,0($20)
   sb    $21,0($20)

 
   
   #c: ADDIU
   ori   $2,$0,'c'
   sb    $2,0($20)
   ori   $4,$0,50
   addiu $5,$4,15
   sb    $5,0($20)    #A
   sb    $23,0($20)
   sb    $21,0($20)

   #d: ADDU
   ori   $2,$0,'d'
   sb    $2,0($20)
   ori   $3,$0,5
   ori   $4,$0,60
   add   $2,$3,$4
   sb    $2,0($20)    #A
   sb    $23,0($20)
   sb    $21,0($20)

   li    $2,0x00000000   
   li    $3,0x00000000
   li    $4,0x00000000  

   #i: SLT
   ori   $2,$0,'i'
   sb    $2,0($20)
   ori   $2,$0,10
   ori   $3,$0,12
   slt   $4,$2,$3
   addi  $5,$4,64
   sb    $5,0($20)    #A


   slt   $4,$3,$2
   addi  $5,$4,66
   sb    $5,0($20)    #B

   li    $2,0xfffffff0
   slt   $4,$2,$3
   addi  $5,$4,66
   sb    $5,0($20)    #C
   
   slt   $4,$3,$2
   addi  $5,$4,68
   sb    $5,0($20)    #D

   li    $3,0xffffffff
   slt   $4,$2,$3
   addi  $5,$4,68
   sb    $5,0($20)    #E
   
   slt   $4,$3,$2
   addi  $5,$4,70
   sb    $5,0($20)    #F
   
   
   sb    $23,0($20)
   sb    $21,0($20)

  
   #j: SLTI
   ori   $2,$0,'j'
   sb    $2,0($20)
   ori   $2,$0,10
   slti  $4,$2,12
   addi  $5,$4,64
   sb    $5,0($20)    #A
   slti  $4,$2,8
   addi  $5,$4,66
   sb    $5,0($20)    #B
   sb    $23,0($20)
   sb    $21,0($20)

   #k: SLTIU
   ori   $2,$0,'k'
   sb    $2,0($20)
   ori   $2,$0,10
   sltiu $4,$2,12
   addi  $5,$4,64
   sb    $5,0($20)    #A
   sltiu $4,$2,8
   addi  $5,$4,66
   sb    $5,0($20)    #B
   sb    $23,0($20)
   sb    $21,0($20)

   #l: SLTU
   ori   $2,$0,'l'
   sb    $2,0($20)
   ori   $2,$0,10
   ori   $3,$0,12
   slt   $4,$2,$3
   addi  $5,$4,64
   sb    $5,0($20)    #A
   slt   $4,$3,$2
   addi  $5,$4,66
   sb    $5,0($20)    #B
   sb    $23,0($20)
   sb    $21,0($20)

   #m: SUB
   ori   $2,$0,'m'
   sb    $2,0($20)
   ori   $3,$0,70
   ori   $4,$0,5
   sub   $2,$3,$4
   sb    $2,0($20)    #A
   sb    $23,0($20)
   sb    $21,0($20)
   
   #mtc0 rd, fs
   #Moves data from general purpose register rt to coprocessor 0 register rd.
   #31-26   25-21 20-16   15-11 10-0 
   #010000 00100  rt      fs    00000000000 
   
   #mtc0 $2,$4
     
   #n: SUBU
   ori   $2,$0,'n'
   sb    $2,0($20)
   ori   $3,$0,70
   ori   $4,$0,5
   sub   $2,$3,$4
   sb    $2,0($20)    #A
   sb    $23,0($20)
   sb    $21,0($20)

   #mfc0 rd, fs
   #Moves data from coprocessor 0 register fs to general purpose register rt. 
   #010000 00000 rt fs 00000000000  
   #mfc0  $17,$9
   
 
   jal   uart_empty  
   ######################################
   #Load, Store, and Memory Control Instructions
   ######################################
LoadTest:
   ori   $2,$0,'L'
   sb    $2,0($20)
   ori   $2,$0,'o'
   sb    $2,0($20)
   ori   $2,$0,'a'
   sb    $2,0($20)
   ori   $2,$0,'d'
   sb    $2,0($20)
   sb    $23,0($20)
   sb    $21,0($20)
   
   li    $25, 0x00002000
   #a: LB
   ori   $2,$0,'a'
   sb    $2,0($20)   

   ori   $2,$0,'A'
   
   sb    $2,0($25)      
   or    $2,$0,$24
   li    $3,0x414243fc
   sw    $3,16($25)
   
   lb    $2,0($25) 
   sb    $2,0($20) #A   
   li    $2,0x42434445
   
   sw    $2,4($25)
   
   
   lb    $4,4($25)
   lb    $5,5($25)
   lb    $6,6($25)
   lb    $7,7($25)      
   
   sb    $4,0($20) #B
   sb    $5,0($20) #C
   sb    $6,0($20) #D
   sb    $7,0($20) #E         
   
   addi  $7,$7,1
   sb    $7,0($25)      
   lb    $2,0($25)
   sb    $7,0($20) #F            
   sb    $23,0($20)
   sb    $21,0($20)   

   #b: LBU
   ori   $2,$0,'b'
   sb    $2,0($20)      
   or    $2,$0,$24
   li    $3,0x414243fc
   sw    $3,16($25)
   ori   $2,$0,'A'
   sb    $2,0($25)   
   lbu   $2,0($25) 
   sb    $2,0($20) #A
   li    $2,0x42434445
   
   sw    $2,4($25)
   
   
   lbu   $4,4($25)
   lbu   $5,5($25)
   lbu   $6,6($25)
   lbu   $7,7($25)      
   
   sb    $4,0($20) #B
   sb    $5,0($20) #C
   sb    $6,0($20) #D
   sb    $7,0($20) #E         
   
   addi  $7,$7,1
   sb    $7,0($25)      
   lbu    $2,0($25)
   sb    $7,0($20) #F            
   sb    $23,0($20)
   sb    $21,0($20)      
   
 

   #c: LH
   ori   $2,$0,'c'
   sb    $2,0($20)
   or    $2,$0,$24
   li    $3,0x00410042
   sw    $3,16($2)
   lh    $4,16($2)
   sb    $4,0($20)
   lh    $2,18($2)
   sb    $2,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #d: LHU
   ori   $2,$0,'d'
   sb    $2,0($20)
   or    $2,$0,$24
   li    $3,0x00410042
   sw    $3,16($2)
   lh    $4,16($2)
   sb    $4,0($20)
   lh    $2,18($2)
   sb    $2,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #e: LW
   ori   $2,$0,'e'
   sb    $2,0($20)
   or    $2,$0,$24
   li    $3,'A'
   sw    $3,16($2)
   ori   $3,$0,0
   lw    $2,16($2)
   sb    $2,0($20)
   sb    $23,0($20)
   sb    $21,0($20)



   

   #f: SB
   ori   $2,$0,'f'
   sb    $2,0($20)
   ori   $2,$0,'A'
   sb    $2,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #g: SH
   ori   $2,$0,'g'
   sb    $2,0($20)
   or    $4,$0,$24
   ori   $2,$0,0x4142
   sh    $2,16($4)
   lb    $3,16($4)
   sb    $3,0($20)
   lb    $2,17($4)
   sb    $2,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #h: SW
   ori   $2,$0,'h'
   sb    $2,0($20)
   or    $2,$0,$24
   li    $3,0x41424344
   sw    $3,16($2)
   lb    $4,16($2)
   sb    $4,0($20)
   lb    $4,17($2)
   sb    $4,0($20)
   lb    $4,18($2)
   sb    $4,0($20)
   lb    $2,19($2)
   sb    $2,0($20)
   sb    $23,0($20)
   sb    $21,0($20)


  jal   uart_empty
  
   ######################################
   #Load, Store, and Memory Control Instructions
   ######################################
#SWR,LWR....:
   ori   $2,$0,'S'
   sb    $2,0($20)
   ori   $2,$0,'W'
   sb    $2,0($20)
   ori   $2,$0,'L'
   sb    $2,0($20)
   sb    $23,0($20)
   sb    $21,0($20)


   or    $2,$0,$24
   li    $3,0xffffffff  
   sw    $3,0($24)
   sw    $3,4($24)
   li    $3,0x41424344
   swl   $3,2($24)
   lb    $2,0($24)
   sb    $2,0($20) #FF
   lb    $2,1($24)
   sb    $2,0($20) #FF
   lb    $2,2($24)
   sb    $2,0($20) #A
   lb    $2,3($24)
   sb    $2,0($20) #B
   sb    $23,0($20)
   sb    $21,0($20)
SWR:
   ori   $2,$0,'S'
   sb    $2,0($20)
   ori   $2,$0,'W'
   sb    $2,0($20)
   ori   $2,$0,'R'
   sb    $2,0($20)
   sb    $23,0($20)
   sb    $21,0($20)
  

   li    $3,0  
   sw    $3,0($2) 
   li    $3,0x41424344 
   swr   $3,7($24)
   lb    $4,4($24)
   sb    $4,0($20)
   lb    $4,5($24)
   sb    $4,0($20)
   lb    $4,6($24)
   sb    $4,0($20)
   lb    $2,7($24)
   sb    $2,0($20)
   
   sb    $23,0($20)
   sb    $21,0($20)

LWL:
   ori   $2,$0,'L'
   sb    $2,0($20)
   ori   $2,$0,'W'
   sb    $2,0($20)
   ori   $2,$0,'L'
   sb    $2,0($20)
   sb    $23,0($20)
   sb    $21,0($20)
  
   #a: LWL 0
   ori   $2,$0,'a'
   sb    $2,0($20)
   or    $2,$0,0
   li    $3,0x44434241
   sw    $3,0($24)
   
       
   li    $2,0x47474741
    
   lwl   $2,0($24) 
   sb    $2,0($20) #A
   sra   $2,$2,8
   sb    $2,0($20) #B  
   sra   $2,$2,8
   sb    $2,0($20) #C  
   sra   $2,$2,8
   sb    $2,0($20) #D
   sb    $23,0($20)
   sb    $21,0($20)


  #b: LWL 1
   ori   $2,$0,'b'
   sb    $2,0($20)
   or    $2,$0,0
   li    $3,0x45444342
   sw    $3,0($24)
   
       
   li    $2,0x47474741
    
   lwl   $2,1($24) 
   sb    $2,0($20) #A
   sra   $2,$2,8
   sb    $2,0($20) #B  
   sra   $2,$2,8
   sb    $2,0($20) #C  
   sra   $2,$2,8
   sb    $2,0($20) #D

   sb    $23,0($20)
   sb    $21,0($20)


   #c: LWL 2
   ori   $2,$0,'c'
   sb    $2,0($20)
   or    $2,$0,0
   li    $3,0x44434443
   sw    $3,0($24)
   
       
   ori   $2,0x4241
    
   lwl   $2,2($24) 
   sb    $2,0($20) #A
   sra   $2,$2,8
   sb    $2,0($20) #B  
   sra   $2,$2,8
   sb    $2,0($20) #C  
   sra   $2,$2,8
   sb    $2,0($20) #D
   sb    $23,0($20)
   sb    $21,0($20)
  
   
  #d: LWL 3
   ori   $2,$0,'d'
   sb    $2,0($20)
   or    $2,$0,0
   li    $3,0x49474844
   sw    $3,0($24)
   
       
   li    $2,0x00434241
    
   lwl   $2,3($24) 
   sb    $2,0($20) #A
   sra   $2,$2,8
   sb    $2,0($20) #B  
   sra   $2,$2,8
   sb    $2,0($20) #C  
   sra   $2,$2,8
   sb    $2,0($20) #D
   sb    $23,0($20)
   sb    $21,0($20)   
   
   
   #f  LWR
   ori   $2,$0,'f'
   sb    $2,0($20)
   li    $3,0x41474849
   sw    $3,0($24)     
         
   li    $2,0x44434280       
   lwr   $2,0($24)
   sb    $2,0($20) #FF  
   sra   $2,$2,8
   sb    $2,0($20) #FF  
   sra   $2,$2,8
   sb    $2,0($20) #FF  
   sra   $2,$2,8
   sb    $2,0($20) #FF   
 
 
   sb    $23,0($20)
   sb    $21,0($20)
   
   #k  LWR
   ori   $2,$0,'k'
   sb    $2,0($20)
   li    $3,0x42414849
   sw    $3,0($24)     
         
   li    $2,0x44434780       
   lwr   $2,1($24)
   sb    $2,0($20) #FF  
   sra   $2,$2,8
   sb    $2,0($20) #FF  
   sra   $2,$2,8
   sb    $2,0($20) #FF  
   sra   $2,$2,8
   sb    $2,0($20) #FF   
 
 
   sb    $23,0($20)
   sb    $21,0($20)  
   
  #l  LWR
   ori   $2,$0,'l'
   sb    $2,0($20)
   li    $3,0x43424148
   sw    $3,0($24)     
         
   li    $2,0x44454780       
   lwr   $2,2($24)
   sb    $2,0($20) #FF  
   sra   $2,$2,8
   sb    $2,0($20) #FF  
   sra   $2,$2,8
   sb    $2,0($20) #FF  
   sra   $2,$2,8
   sb    $2,0($20) #FF   
 
 
   sb    $23,0($20)
   sb    $21,0($20)  
      

  #l  LWR
   ori   $2,$0,'k'
   sb    $2,0($20)
   li    $3,0x44434241
   sw    $3,0($24)     
         
   li    $2,0x33454780       
   lwr   $2,3($24)
   sb    $2,0($20) #FF  
   sra   $2,$2,8
   sb    $2,0($20) #FF  
   sra   $2,$2,8
   sb    $2,0($20) #FF  
   sra   $2,$2,8
   sb    $2,0($20) #FF   
 
 
   sb    $23,0($20)
   sb    $21,0($20)  
         
  jal   uart_empty
   
   ######################################
   #Branch and Jump Instructions
   ######################################

BranchTest:
   ori   $2,$0,'B'
   sb    $2,0($20)
   ori   $2,$0,'r'
   sb    $2,0($20)
   ori   $2,$0,'a'
   sb    $2,0($20)
   ori   $2,$0,'n'
   sb    $2,0($20)
   ori   $2,$0,'c'
   sb    $2,0($20)
   ori   $2,$0,'h'
   sb    $2,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #a: B
   ori   $2,$0,'a'
   sb    $2,0($20)
   ori   $10,$0,'A'
   ori   $11,$0,'B'
   b     $B1
   sb    $10,0($20)  #A
   sb    $10,0($20)  #darf nicht schreiben
$B1:
   sb    $11,0($20)  #B
   sb    $23,0($20)
   sb    $21,0($20)

   #b: BAL
   ori   $2,$0,'b'
   sb    $2,0($20)
   ori   $10,$0,'A'
   ori   $11,$0,'B'
   ori   $12,$0,'C'
   ori   $13,$0,'D'
   ori   $14,$0,'E'
   ori   $15,$0,'X'
   bal   $BAL1
   sb    $10,0($20)  #A
   sb    $13,0($20)  #D 
   b     $BAL2
   sb    $14,0($20)
   sb    $15,0($20)
$BAL1:
   sb    $11,0($20)  #B
   
   jr    $31
   sb    $12,0($20)  #C
   sb    $22,0($20)
$BAL2:
   sb    $23,0($20)
   sb    $21,0($20)

   #c: BEQ
   ori   $2,$0,'c'
   sb    $2,0($20)
   ori   $10,$0,'A'
   ori   $11,$0,'B'
   ori   $12,$0,'C'
   ori   $13,$0,'D'
   ori   $2,$0,100
   ori   $3,$0,123
   ori   $4,$0,123
   beq   $2,$3,$BEQ1
   sb    $10,0($20)
   sb    $11,0($20)
   beq   $3,$4,$BEQ1
   sb    $12,0($20)
   sb    $22,0($20)
$BEQ1:
   sb    $13,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #d: BGEZ
   ori   $2,$0,'d'
   sb    $2,0($20)
   ori   $10,$0,'A'
   ori   $11,$0,'B'
   ori   $12,$0,'C'
   ori   $13,$0,'D'
   or    $15,$0,'X'
   ori   $2,$0,100
   li    $3,0xffff1234
   ori   $4,$0,123
   bgez  $3,$BGEZ1
   sb    $10,0($20)
   sb    $11,0($20)
   bgez  $2,$BGEZ1
   sb    $12,0($20)
   sb    $22,0($20)
$BGEZ1:
   bgez  $0,$BGEZ2
   nop
   sb    $15,0($20)
$BGEZ2:
   sb    $13,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #e: BGEZAL
   ori   $2,$0,'e'
   sb    $2,0($20)
   ori   $10,$0,'A'
   ori   $11,$0,'B'
   ori   $12,$0,'C'
   ori   $13,$0,'D'
   ori   $14,$0,'E'
   ori   $15,$0,'X'
   li    $3,0xffff1234
   bgezal $3,$BGEZAL1
   nop
   sb    $10,0($20)
   bgezal $0,$BGEZAL1
   nop
   sb    $13,0($20)
   b     $BGEZAL2
   sb    $14,0($20)
   sb    $15,0($20)
$BGEZAL1:
   sb    $11,0($20)
   jr    $31
   sb    $12,0($20)
   sb    $22,0($20)
$BGEZAL2:
   sb    $23,0($20)
   sb    $21,0($20)

   #f: BGTZ
   ori   $2,$0,'f'
   sb    $2,0($20)
   ori   $10,$0,'A'
   ori   $11,$0,'B'
   ori   $12,$0,'C'
   ori   $13,$0,'D'
   ori   $2,$0,100
   li    $3,0xffff1234
   bgtz  $3,$BGTZ1
   sb    $10,0($20)
   sb    $11,0($20)
   bgtz  $2,$BGTZ1
   sb    $12,0($20)
   sb    $22,0($20)
$BGTZ1:
   sb    $13,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #g: BLEZ
   ori   $2,$0,'g'
   sb    $2,0($20)
   ori   $10,$0,'A'
   ori   $11,$0,'B'
   ori   $12,$0,'C'
   ori   $13,$0,'D'
   ori   $2,$0,100
   li    $3,0xffff1234
   blez  $2,$BLEZ1  # not jump
   sb    $10,0($20) #A 
   sb    $11,0($20) #B
   blez  $3,$BLEZ1
   sb    $12,0($20)
   sb    $22,0($20)
$BLEZ1:
   blez  $0,$BLEZ2
   nop
   sb    $22,0($20)
$BLEZ2:
   sb    $13,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #h: BLTZ
   ori   $2,$0,'h'
   sb    $2,0($20)
   ori   $10,$0,'A'
   ori   $11,$0,'B'
   ori   $12,$0,'C'
   ori   $13,$0,'D'
   ori   $14,$0,'E'
   ori   $2,$0,100
   li    $3,0xffff1234
   ori   $4,$0,0
   bltz  $2,$BLTZ1
   sb    $10,0($20)
   sb    $11,0($20)
   bltz  $3,$BLTZ1
   sb    $12,0($20)
   sb    $22,0($20)
$BLTZ1:
   bltz  $4,$BLTZ2
   nop
   sb    $13,0($20)
$BLTZ2:
   sb    $14,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #i: BLTZAL
   ori   $2,$0,'i'
   lui   $3,0x9999
   sb    $2,0($20)
   ori   $10,$0,'A'
   ori   $11,$0,'B'
   ori   $12,$0,'C'
   ori   $13,$0,'D'
   ori   $14,$0,'E'
   ori   $15,$0,'X'
   li    $3,0xffff1234
   bltzal $0,$BLTZAL1  #not jump
   nop
   sb    $10,0($20)   #A
   bltzal $3,$BLTZAL1
   sb    $11,0($20)   #B   # code korrigieren   !!!!!
   b     $BLTZAL2
   sb    $14,0($20)
   sb    $15,0($20)
$BLTZAL1:
   sb    $12,0($20)  #C
   jr    $31
   sb    $13,0($20)  #D
   sb    $22,0($20)
$BLTZAL2:
   sb    $23,0($20)
   sb    $21,0($20)

   #j: BNE
   ori   $2,$0,'j'
   sb    $2,0($20)
   ori   $10,$0,'A'
   ori   $11,$0,'B'
   ori   $12,$0,'C'
   ori   $13,$0,'D'
   ori   $2,$0,100
   ori   $3,$0,123
   ori   $4,$0,123
   bne   $3,$4,$BNE1
   sb    $10,0($20)
   sb    $11,0($20)
   bne   $2,$3,$BNE1
   sb    $12,0($20)
   sb    $22,0($20)
$BNE1:
   sb    $13,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #k: J
   ori   $2,$0,'k'
   sb    $2,0($20)
   ori   $10,$0,'A'
   ori   $11,$0,'B'
   ori   $15,$0,'X'
   j     $J1
   sb    $10,0($20)
   sb    $15,0($20)
$J1:
   sb    $11,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #l: JAL
   ori   $2,$0,'l'
   sb    $2,0($20)
   ori   $10,$0,'A'
   ori   $11,$0,'B'
   ori   $12,$0,'C'
   ori   $13,$0,'D'
   ori   $14,$0,'E'
   ori   $15,$0,'X'
   jal   $JAL1
   sb    $10,0($20)  #A
   sb    $13,0($20)  #D
   b     $JAL2
   sb    $14,0($20)  #E
   sb    $15,0($20)
$JAL1:
   sb    $11,0($20)  #B
   jr    $31
   sb    $12,0($20)  #C
   sb    $15,0($20)
$JAL2:
   sb    $23,0($20)
   sb    $21,0($20)



   #m: JALR
   ori   $2,$0,'m'
   sb    $2,0($20)
   ori   $10,$0,'A'
   ori   $11,$0,'B'
   ori   $12,$0,'C'
   ori   $13,$0,'D'
   ori   $14,$0,'E'
   ori   $15,$0,'X'
   la    $3,$JALR1
   jalr  $3
   sb    $10,0($20)
   sb    $13,0($20)
   b     $JALR2
   sb    $14,0($20)
   sb    $15,0($20)
$JALR1:
   sb    $11,0($20)
   jr    $31
   sb    $12,0($20)
   sb    $22,0($20)
$JALR2:
   sb    $23,0($20)
   sb    $21,0($20)

   #n: JR
   ori   $2,$0,'n'
   sb    $2,0($20)
   ori   $10,$0,'A'
   ori   $11,$0,'B'
   ori   $15,$0,'X'
   la    $3,$JR1
   jr    $3
   sb    $10,0($20)
   sb    $15,0($20)
$JR1:
   sb    $11,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #o: NOP
   ori   $2,$0,'o'
   sb    $2,0($20)
   ori   $2,$0,65
   nop
   sb    $2,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   jal   uart_empty


   ######################################
   #Shift Instructions
   ######################################
ShiftTest:
   ori   $2,$0,'S'
   sb    $2,0($20)
   ori   $2,$0,'h'
   sb    $2,0($20)
   ori   $2,$0,'i'
   sb    $2,0($20)
   ori   $2,$0,'f'
   sb    $2,0($20)
   ori   $2,$0,'t'
   sb    $2,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #a: SLL
   ori   $2,$0,'a'
   sb    $2,0($20)
   li    $2,0x40414243
   sll   $3,$2,8
   srl   $3,$3,24
   sb    $3,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #b: SLLV
   ori   $2,$0,'b'
   sb    $2,0($20)
   li    $2,0x40414243
   ori   $3,$0,8
   sllv  $3,$2,$3
   srl   $3,$3,24
   sb    $3,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #c: SRA
   ori   $2,$0,'c'
   sb    $2,0($20)
   li    $2,0x40414243
   sra   $3,$2,16
   sb    $3,0($20)
   li    $2,0x84000000
   sra   $3,$2,25
   sub   $3,$3,0x80
   sb    $3,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #d: SRAV
   ori   $2,$0,'d'
   sb    $2,0($20)
   li    $2,0x40414243
   ori   $3,$0,16
   srav  $3,$2,$3
   sb    $3,0($20)
   ori   $3,$0,25
   li    $2,0x84000000
   srav  $3,$2,$3
   sub   $3,$3,0x80
   sb    $3,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #e: SRL
   ori   $2,$0,'e'
   sb    $2,0($20)
   li    $2,0x40414243
   srl   $3,$2,16
   sb    $3,0($20)
   li    $2,0x84000000
   srl   $3,$2,25
   sb    $3,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #f: SRLV
   ori   $2,$0,'f'
   sb    $2,0($20)
   li    $2,0x40414243
   ori   $3,$0,16
   srlv  $4,$2,$3
   sb    $4,0($20)
   ori   $3,$0,25
   li    $2,0x84000000
   srlv  $3,$2,$3
   sb    $3,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   jal   uart_empty


   ######################################
   #Logical Instructions
   ######################################
LogicalTest:
   ori   $2,$0,'L'
   sb    $2,0($20)
   ori   $2,$0,'o'
   sb    $2,0($20)
   ori   $2,$0,'g'
   sb    $2,0($20)
   ori   $2,$0,'i'
   sb    $2,0($20)
   ori   $2,$0,'c'
   sb    $2,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #a: AND
   ori   $2,$0,'a'
   sb    $2,0($20)
   ori   $2,$0,0x0741
   ori   $3,$0,0x60f3
   and   $4,$2,$3
   sb    $4,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   
   #b: ANDI
   ori   $2,$0,'b'
   sb    $2,0($20)
   ori   $2,$0,0x0741
   andi  $4,$2,0x60f3
   sb    $4,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #c: LUI
   ori   $2,$0,'c'
   sb    $2,0($20)
   lui   $2,0x41
   srl   $3,$2,16
   sb    $3,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #d: NOR
   ori   $2,$0,'d'
   sb    $2,0($20)
   li    $2,0xf0fff08e
   li    $3,0x0f0f0f30
   nor   $4,$2,$3
   sb    $4,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #e: OR
   ori   $2,$0,'e'
   sb    $2,0($20)
   ori   $2,$0,0x40
   ori   $3,$0,0x01
   or    $4,$2,$3
   sb    $4,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #f: ORI
   ori   $2,$0,'f'
   sb    $2,0($20)
   ori   $2,$0,0x40
   ori   $4,$2,0x01
   sb    $4,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #g: XOR
   ori   $2,$0,'g'
   sb    $2,0($20)
   ori   $2,$0,0xf043
   ori   $3,$0,0xf002
   xor   $4,$2,$3
   sb    $4,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

   #h: XORI
   ori   $2,$0,'h'
   sb    $2,0($20)
   ori   $2,$0,0xf043
   xor   $4,$2,0xf002
   sb    $4,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

 #  jal   uart_empty 

   ori   $2,$0,'D'
   sb    $2,0($20)
   ori   $2,$0,'o'
   sb    $2,0($20)
   ori   $2,$0,'n'
   sb    $2,0($20)
   ori   $2,$0,'e'
   sb    $2,0($20)
   sb    $23,0($20)
   sb    $21,0($20)



BreakTest:
   #p: BREAK
   ori   $2,$0,'p'
   sb    $2,0($20)
   ori   $2,$0,'z'
   ori   $4,$0,59
   break 0
   addi  $4,$4,1
   sb    $4,0($20)
   sb    $23,0($20)
   sb    $21,0($20)

  
uart_empty:
   lb    $10,-4($20)
   beqz  $10,uart_empty
   nop
   jr    $31
   nop        
   
   
   
   
  
.end

