



typedef signed short int  int16_t;
typedef unsigned short int  uint16_t;
typedef signed int          int32_t;



//Testmatix
//int16_t matrix[]={168,161,161,150,154,168,164,154,
                    //171,154,161,150,157,171,150,164,
                    //171,168,147,164,164,161,143,154,
                    //164,171,154,161,157,157,147,132,
                    //161,161,157,154,143,161,154,132,
                    //164,161,161,154,150,157,154,140,
                    //161,168,157,154,161,140,140,132,
                    //154,161,157,150,140,132,136,128};

// matrix-128
int16_t matrix[]={40,33,33,22,26,40,36,26,
                  43,26,33,22,29,43,22,36,
                  43,40,19,36,36,33,15,26,
                  36,43,26,33,29,29,19,4,
                  33,33,29,26,15,33,26,4,
                  36,33,33,26,22,29,26,12,
                  33,40,29,26,33,12,12,4,
                  26,33,29,22,12, 4, 8,0};


                
int16_t *daten= matrix;            

	

/* DCT for One block(8x8) */
void cDCT(int16_t *data)
  {

    uint16_t i;
    int32_t x0, x1, x2, x3, x4, x5, x6, x7, x8;

    static const uint16_t c1=1420;    // cos PI/16 * root(2)
    static const uint16_t c2=1338;    // cos PI/8 * root(2)
    static const uint16_t c3=1204;    // cos 3PI/16 * root(2)
    static const uint16_t c5=805;     // cos 5PI/16 * root(2)
    static const uint16_t c6=554;     // cos 3PI/8 * root(2)
    static const uint16_t c7=283;     // cos 7PI/16 * root(2)

    static const uint16_t s1=3;
    static const uint16_t s2=10;
    static const uint16_t s3=13;

    for (i=8; i>0; i--)
    {
        x8 = data [0] + data [7];
        x0 = data [0] - data [7];

        x7 = data [1] + data [6];
        x1 = data [1] - data [6];

        x6 = data [2] + data [5];
        x2 = data [2] - data [5];

        x5 = data [3] + data [4];
        x3 = data [3] - data [4];

        x4 = x8 + x5;
        x8 = x8 - x5;

        x5 = x7 + x6;
        x7 = x7 - x6;

        data [0] = (int16_t) (x4 + x5);
        data [4] = (int16_t) (x4 - x5);

        data [2] = (int16_t) ((x8*c2 + x7*c6) >> s2);
        data [6] = (int16_t) ((x8*c6 - x7*c2) >> s2);

        data [7] = (int16_t) ((x0*c7 - x1*c5 + x2*c3 - x3*c1) >> s2);
        data [5] = (int16_t) ((x0*c5 - x1*c1 + x2*c7 + x3*c3) >> s2);
        data [3] = (int16_t) ((x0*c3 - x1*c7 - x2*c1 - x3*c5) >> s2);
        data [1] = (int16_t) ((x0*c1 + x1*c3 + x2*c5 + x3*c7) >> s2);

        data += 8;
    }

    data -= 64;

    for (i=8; i>0; i--)
    {
        x8 = data [0] + data [56];
        x0 = data [0] - data [56];

        x7 = data [8] + data [48];
        x1 = data [8] - data [48];

        x6 = data [16] + data [40];
        x2 = data [16] - data [40];

        x5 = data [24] + data [32];
        x3 = data [24] - data [32];

        x4 = x8 + x5;
        x8 = x8 - x5;

        x5 = x7 + x6;
        x7 = x7 - x6;

        data [0] = (int16_t) ((x4 + x5) >> s1);
        data [32] = (int16_t) ((x4 - x5) >> s1);

        data [16] = (int16_t) ((x8*c2 + x7*c6) >> s3);
        data [48] = (int16_t) ((x8*c6 - x7*c2) >> s3);

        data [56] = (int16_t) ((x0*c7 - x1*c5 + x2*c3 - x3*c1) >> s3);
        data [40] = (int16_t) ((x0*c5 - x1*c1 + x2*c7 + x3*c3) >> s3);
        data [24] = (int16_t) ((x0*c3 - x1*c7 - x2*c1 - x3*c5) >> s3);
        data [8] = (int16_t) ((x0*c1 + x1*c3 + x2*c5 + x3*c7) >> s3);

        data++;
    }
  }
/*
 * output to UART
 */
int putDebugChar(char c)
  {   
    volatile char*  p_status= (volatile int*)0x20000007;
    while ((*p_status)&0x02){};
    *((volatile char*)0x20000008)=c;
    return 1;
  }

void output (char* str)
  {
	  while (*str){
        volatile char*  p_status= (volatile int*)0x20000007;
        while ((*p_status)&0x02){};
        *((volatile char*)0x20000008)=(*str);
        str++;
        } 
    }     	  




char *  itoa ( int value, char * str)		

   {
   //value    Value to be converted to a string.
   //str      Array in memory where to store the resulting null-terminated string.
   
   //base     Numerical base used to represent the value as a string, 
   //         between 2 and 36, where 10 means decimal base, 16 hexadecimal, 8 octal, and 2 binary.
   
   //Return Value
   //A pointer to the resulting null-terminated string, same as parameter str.
   
   char save[32];
   int counter =0;
   char *p_c=str;
   if ( (value<0))
      {
		*p_c='-';
		p_c++;
		value=0-value;
	  }
	  
	  while (value)
	    {
	      save[counter]=value%10;
	      value=value/10;
	      counter++;
	     }
	  
	  while (counter--)
	     { 	 
	          *p_c=(char)('0'+save[counter]);
	           p_c++;
          }
          *p_c=(char) 0; // zero terminated
  return str;
  }          


int main(){
  int i,j;
  char puffer[32];

  cDCT(matrix);	

 
  for (j=0; j< 64; j=j+8)
    {
    for (i=0; i< 8; i++)
       {    
          output(itoa(matrix[i+j],puffer));
          putDebugChar(' ');
        }  
    putDebugChar(0xD);
    }

}
